#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

/*
	THE FOLLOWING ROUTINES ARE FROM PART ONE AND TWO OF THE TUTORIAL
*/
char *vga = MK_FP(0xA000, 0);

void SetMode13h()
{
	union REGS regs;
	regs.x.ax = 0x013;
	int86(0x10, &regs, &regs);
}

void SetTextMode()
{
	union REGS regs;
	regs.x.ax = 0x003;
	int86(0x10, &regs, &regs);
}

void PlotPixel(int x, int y, char colour)
{
	int offset;
	offset = (y*320) +x;
	*(vga + offset)=colour;
}

void HorizontalLine(int x1, int y, int x2, int colour)
{
	int xcount;

	for(xcount = x1; xcount <= x2; xcount++)
	{
		*(vga+(y*320)+xcount)=colour;
	}
}

/*
	THE FOLLOWING ARE OUR PALETTE ROUTINES AND VERTICAL RETRACE ROUTINE
*/

// get an individual palette register
void GetPal(char ColorNumber, unsigned char *R, unsigned char *G, unsigned char *B)
{
	outp(0x3c7, ColorNumber);  	// this is the color we want to read
	*R = inp(0x3c9);		// R value
	*G = inp(0x3c9);        // G value
	*B = inp(0x3c9);		// B value
}

// set an individual palette register
void Pal(char ColorNumber, unsigned char R, unsigned char G, unsigned char B)
{
	outp(0x3c7, ColorNumber);	// the color value we want to set
	outp(0x3c9, R);			// R value
	outp(0x3c9, G);			// G value
	outp(0x3c9, B);			// B value
}

// wait for vertical retrace
void WaitRetrace()
{
	while ((inp(0x03DA)&0x08)==0);
}

void Fadeout()
{
	// This is temporary storage for the values of a color
	unsigned char Tmp[3];
	int loop1, loop2;

	for(loop1=0; loop1<64; loop1++)
	{
		WaitRetrace();	// if the routine is too fast try placing a delay b4 the
						// wait retrace
		for(loop2=0; loop2<256; loop2++)
		{
			GetPal(loop2,&Tmp[0],&Tmp[1],&Tmp[2]);

			// If the Red, Green or Blue values of color are not yet zero
			// decrease them by one.
			if(Tmp[0] > 0) Tmp[0]--;
			if(Tmp[1] > 0) Tmp[1]--;
			if(Tmp[2] > 0) Tmp[2]--;

			// Set the new pallette color.
			Pal(loop2,Tmp[0],Tmp[1],Tmp[2]);
		}
	}
}

void main()
{
	int i;

	SetMode13h();

	// fill the screen with lines
	for(i = 0; i < 200; i++)
	{
		HorizontalLine(0,i,320,i);
	}
	getch();

	Fadeout();

	getch();

	SetTextMode();
}